<template>
  <div class="hello">
    <h1 v-text="msg">{{ msg }}</h1>

    <div class="row">
      <div> <input type="text" v-model="nickname"/> </div>

      <button class="button button-humain" @click="setJoueur">
        Joueur
      </button>

      <button class="button button-ia" @click="iAExecute">
        IA
      </button>

    </div>


    <div class="row"> 
       <h1>Score : {{board.points}}</h1>
      </div>
 

<div class="row">
    <div class="board" >
      <div class="board-row" v-for="(ligne , lignes) in board.squares" :key="lignes">
        <div class="cell" v-for="(colone,colones) in board.squares" :key="colones" :class="bgColor(board.get(colones,lignes))">
          <div class="number" v-if="board.get(colones,lignes)!= 0" >{{ board.get(colones,lignes) }}</div>
        </div>
      </div>
      
    </div>
</div>
</div>

</template>

<script>
import board from "@/utils/Board";
import http from "@/api/http"

let moveUp = 0;

export default {
  name: "Game",
  mounted() {
    window.addEventListener("keydown", this.handleKeyEvent.bind(this));
  },
  data() {
    return {
      msg: "Welcome to Your 2048 game",
      board: board,
      nickname:'default-player',
      joueur:'',
    };
  },

  created() {
    board.init(4);
    this.counter = setInterval(this.startCounter(),1000)
    
  },

  methods: {
    handleKeyEvent(event) {
      //Disable scrolling when arrow button is pressed
      window.addEventListener("keydown", function(e) {
      if([32, 37, 38, 39, 40].indexOf(e.keyCode) > -1) {
        e.preventDefault();
    }
}, false);
      console.log(event.keyCode);
      if (board.isOver()) {
        let score = board.points
        console.log('Score : ' +score);
        this.show();
        http
        .get(`${this.nickname}/${score}/60`)
        .then(response =>{
            console.log(response.data)
        })
        .catch(error =>{
          console.error(error)
        })
        
  
      }
      switch (event.keyCode) {
        case 37:
          board.move("left");
          break;
        case 38:
          board.move("up");
          break;
        case 39:
          board.move("right");

          break;
        case 40:
          board.move("down");
          break;
        default:
          break;
      }

      this.$forceUpdate();
    },
    show() {
      this.$modal.show("dialog", {
        title: "Game Over!",
        text: "You Lose",
        buttons: [
          {
            title: "Do you want to restart the game",
            default: true, // Will be triggered by default if 'Enter' pressed.
            handler: () => {
              location.reload();
            }
          },
            {
            title: "Best Scores",
            default: true, // Will be triggered by default if 'Enter' pressed.
            handler: () => {
              this.$router.push({path: '/score'})
              this.$router.forward()
              location.reload();
            }
          },

        ]
      });
    },
     bgColor(number){

       let classCss="";
       switch (number) {
         case 2:return "couleur2";           
           break;
         case 4:return "couleur4";           
           break;
         case 8:return "couleur8";           
           break;
         case 16:return "couleur16";           
           break;
         case 32:return "couleur32";           
           break;
         case 64:return "couleur64";           
           break;
         case 128:return "couleur128";           
           break;
         case 256:return "couleur256";           
           break;
         case 512:return "couleur512";           
           break;
         case 1024:return "couleur1024";           
           break;
         case 2048:return "couleur2048";           
           break;
       
         default:
           break;
       }

      console.log('je suis dans method bgColor '+number)

    },
    setJoueur(){

        console.log(this.nickname) ;
    },
    saveScore(name){
      let score = board.points
        console.log('Score : ' +score);
        this.show();
        http
        .get(name+`/${score}/60`)
        .then(response =>{
            console.log(response.data)
        })
        .catch(error =>{
          console.error(error)
        })

    },
    iA(){                  
          var tabMove = ["left","right","up","down"]; 
          
          var move = 0;
          if(board.over == false){
            move = Math.floor(Math.random() * 4) + 0 ;
              if(move == 2){
                move = Math.floor(Math.random() * 4) + 0 ;
                moveUp = moveUp +1;
                if(moveUp == 3)
                  {
                    move = 2;
                  moveUp = 0;
                  console.log("moveup x 3");
                  }
              }

            board.move(tabMove[move]);
            this.$forceUpdate(); 
            } 
                 
    },
    iAExecute(){
      if(board.over == false){
        setInterval( this.iA ,2000); 
      }else{
              let nom ="[IA]Nathan-Jed";
              this.saveScore(nom);
            }       
    },
    startCounter(){

    }

  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.row {
  margin-left: -15px;
  margin-right: -15px;
}

.board {
  width: 470px;
  height: 470px;
  margin-left: auto;
  margin-right: auto;
  background-color: #bbada0;
  border: #bbada0 solid 15px;
  border-radius: 12px;
}

.board-row {
  width: 100%;
  height: 100px;
  margin-bottom: 15px;
}

.cell {
  width: 106px;
  height: 106px;
  margin-right: 10px;
  float: left;
  border-radius: 3px;
  background: rgba(238, 228, 218, 0.35);
}
.couleur2{
  color: black;
  background: rgb(240, 233, 226);
}
.couleur4{
  color: black;
      background: #ede0c8;
}
.couleur8{
    color: #f9f6f2;
    background: #f2b179;
}
.couleur16{
 color: #f9f6f2;
    background: #f59563;
}
.couleur32{
      color: #f9f6f2;
    background: #f67c5f;
}
.couleur64{
    color: #f9f6f2;
    background: #f65e3b;
}
.couleur128{
      color: #f9f6f2;
    background: #edcf72;
}
.couleur256{
    color: #f9f6f2;
    background: #edcc61;
    box-shadow: 0 0 30px 10px rgba(243, 215, 116, 0.31746), inset 0 0 0 1px rgba(255, 255, 255, 0.19048)
}
.couleur512{
  background: rgb(240, 233, 226);
}
.couleur1024{
  background: rgb(240, 233, 226);
}
.couleur2048{
  background: rgb(240, 233, 226);
}

.number {
  font-size: 4em;
  padding-top: 18px;
}


.button {
   
    border: none;
    color: white;
    padding: 15px 32px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
} 

.button-ia{
 background-color: rgb(233, 10, 59); 
}

.button-humain{
 background-color: #4CAF50; 
}


h1,
h2 {
  font-weight: normal;
}
</style>
